# $Id: gestalter.spec,v 1.24 2005/05/08 08:03:46 pklaus Exp $

Summary: A free vector drawing application.
Name: gestalter
Version: 0.7.6
Release: 1
License: GPL
Group: Applications/Editors
Source: http://www.linotux.ch/gestalter/gestalter-%{version}.tar.gz
URL: http://www.linotux.ch/gestalter/
BuildRoot: %{_tmppath}/%{name}-root
Requires: gtk+ >= 1.2.0, gtkmm >= 1.2.0, gnomemm >= 1.2.1
Requires: gdk-pixbuf >= 0.18.0, gdk-pixbuf-gnome >= 0.18.0, libsigc++ >= 1.0.0
Requires: libxml2 >= 2.4, freetype >= 2.0.0, glib >= 1.2.0
BuildRequires: gtk+-devel >= 1.2.0, gtkmm-devel >= 1.2.0
BuildRequires: gnomemm-devel >= 1.2.1, gnome-libs >= 1.4.0, gnome-libs-devel
BuildRequires: gdk-pixbuf-devel >= 0.18.0, libsigc++-devel >= 1.0.0
BuildRequires: libxml2-devel >= 2.4, freetype-devel >= 2.0.0
BuildRequires: glib-devel >= 1.2.0

%description
Gestalter is a free vector drawing program. The user interface is loosly
modelled after the famous Illustrator (tm) by Adobe. The central 
element is the Bezier curve used as a base part for almost every other
object. Complex paths are possible, compound paths can be constructed,
grouping of elements is enabled and everything can be screened by a mask.
The drawing can be organized in layers, each having a separate selection
color and viewable/editable settings.
Antialiased diplay is possible as well as wireframe, printing is in postscript.

%define _unpackaged_files_terminate_build 0

%prep
%setup -q

%build
rm -rf %{buildroot}
%configure
make

%install
%makeinstall
install -p -D gestalter.desktop ${RPM_BUILD_ROOT}%{_datadir}/applications/linotux-gestalter.desktop
install -p -D gestalter_icon.png ${RPM_BUILD_ROOT}%{_datadir}/pixmaps/gestalter_icon.png
if [ -x /usr/bin/desktop-file-install ]; then
desktop-file-install --vendor linotux --delete-original \
  --dir ${RPM_BUILD_ROOT}%{_datadir}/applications      \
  --add-category Application                           \
  --add-category Office                                \
  ${RPM_BUILD_ROOT}%{_datadir}/applications/linotux-%{name}.desktop
fi

%files
%defattr(-,root,root)
%doc README COPYING
%{_bindir}/gestalter
%{_prefix}/share/locale/*/LC_MESSAGES/gestalter.mo
%attr(644,root,root)%{_datadir}/pixmaps/gestalter_icon.png
%attr(644,root,root)%{_datadir}/applications/linotux-%{name}.desktop

%changelog
* Wed Jul 21 2004 Philipp Klaus <gestalter@linotux.ch> 0.7.5-1
- new upstream release
- drawing accelerated, especially in zoomed in windows
- bug fixes

* Wed Jun 28 2004 Philipp Klaus <gestalter@linotux.ch> 0.7.4-1
- new upstream release
- activated control combination in bezier tool to change handle behaviour
- text in TrueType fonts can be printed now
- check for changed documents to be saved before closing
- version string in about dialog
- bug fixes

* Wed Jun 18 2004 Philipp Klaus <gestalter@linotux.ch> 0.7.3-1
- new upstream release
- align/distribute dialog
- PathMingler: combine objects based on viewability
- bug fixes in the text tool

* Wed Mar 31 2004 Philipp Klaus <gestalter@linotux.ch> 0.7.2-1
- new upstream release
- guides
- units in dimension entries
- ruler units changeable
- lots of bug fixes (including several memory leaks)

* Wed Mar 23 2004 Philipp Klaus <gestalter@linotux.ch> 0.7.1-1
- new upstream release
- patterns
- bug fixes

* Wed Mar 08 2004 Philipp Klaus <gestalter@linotux.ch> 0.7.0-1
- new upstream release
- gradients
- bug fixes

* Wed Dec 31 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.9-1
- new upstream release
- right adjusted and centered text
- bug fixes

* Thu Nov 23 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.8-1
- new upstream release
- preferences (dialog and file)
- font data cache
- change of xml library to libxml2
- lots of bug fixes

* Thu Oct 25 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.7-1
- new upstream release
- stroke options
- lots of bug fixes

* Thu Sep 18 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.5-1
- new upstream release
- undo/redo
- value input dialogs for most tools

* Tue Jun 24 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.4-1
- new upstream release
- layer management
- copy/paste support

* Sat Mar 05 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.2-1
- new upstream release
- new text properties dialog and configuration option

* Sat Jan 18 2003 Philipp Klaus <gestalter@linotux.ch> 0.6.1-1
- first rpm package
