/* $Id: AddAction.cc,v 1.2 2003/08/31 19:20:28 pklaus Exp $
 *
 * AddAction.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "AddAction.hh"
#include "GObject.hh"
#include "Layer.hh"
#include "BezierPath.hh"
#include "BezierNode.hh"

AddAction::AddAction(GObject *object, Layer *layer) {
	action = "Add";
	addObject = object;
	affectedLayer = layer;
}

AddAction::AddAction(BezierPath *path, BezierNode *node) {
	action = "Append";
	appendPath = path;
	newNode = node;
}

AddAction::AddAction(BezierNode *pNode) {
	action = "Insert";
	previousNode = pNode;
}

AddAction::AddAction(SelectionItemList *pasteList) {
	action = "Paste";
	this->pasteList = pasteList;
}
