/* $Id: BezierTool.hh,v 1.4 2004/06/19 16:27:26 pklaus Exp $
 *
 * BezierTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _BEZIERTOOL_HH
#  define _BEZIERTOOL_HH

#include "Tool.hh"
#include <gdk--.h>

class DocWindow;
class BezierNode;
class GDDocument;

class BezierTool : public Tool {

	gdouble sx, sy;
	gdouble corrX, corrY;

	gboolean closingPath;
	gboolean moveNextHandle;
	void takeOverNode(BezierNode *node, GDDocument *doc);
	void newBezierNode(DocWindow *docwin);
	void checkAxisConstraint(GDDocument *doc, guint state);
	
	Gdk_Cursor bezierCommonCursor;
	Gdk_Cursor bezierAppendCursor;
	Gdk_Cursor bezierNewCursor;
	Gdk_Cursor moveCursor;
	Gdk_Cursor moveMagnetCursor;
	Gdk_Cursor changeHandleCursor;
	
	gboolean nodeCaught;

public:
	BezierTool();
	
	void activate();
	void deactivate();
	gint install();
	gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	gint motion(GdkEventMotion *ev, DocWindow *docwin);
	gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	gint showOptions();
	
	void setCursor(guint state, DocWindow *docwin);
};

#endif
