/* $Id: CircleTool.hh,v 1.3 2003/09/18 20:38:33 pklaus Exp $
 *
 * CircleTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _CIRCLETOOL_HH
#  define _CIRCLETOOL_HH

#include "Tool.hh"
#include "DocWindow.hh"
#include <gdk--.h>
#include "BezierNode.hh"

class DimensionDialog;
class GDDocument;

class CircleTool : public Tool, public SigC::Object {

protected:
	gint startx, starty, oldx, oldy;
	gint downButton;
	
	gdouble sx, sy, cx, cy;

	Gdk_Cursor crosshairCursor;
	Gdk_Cursor moveCursor;
	Gdk_Cursor moveMagnetCursor;
	
	gboolean nodeCaught;

	GDDocument *dialogDoc;
	DimensionDialog *valueDialog;

	void drawCircle(Gdk_Drawable& drawable, Gdk_GC& context,
									gint32 x1, gint32 y1,
									gint32 x2, gint32 y2);
public:
	
	CircleTool();
	
	void activate();
	void deactivate();
	gint install();
	gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	gint motion(GdkEventMotion *ev, DocWindow *docwin);
	gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	gint showOptions();
	
	void setCursor(guint state, DocWindow *docwin);
	void addCircle(GDDocument *doc, gdouble tlx, gdouble tly, gdouble brx, gdouble bry);
	
	void showValueDialog();
	gint deleteValueDialog(GdkEventAny *ev);
	void cancelValueDialog();
	void createObject();

};

#endif
