/* $Id: DrawObject.hh,v 1.8 2004/07/21 06:31:20 pklaus Exp $
 *
 * DrawObject.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _DRAWOBJECT_HH
#  define _DRAWOBJECT_HH

#include "SelectableItem.hh"
#include <gdk--.h>
#include "GDResource.hh"
#include "GDStyle.hh"
#include "DocWindow.hh"

class GDFont;
class TextStyle;


class DrawObject : public SelectableItem {

public:
	virtual void drawWithSelection(OffscreenBuffer& osBuffer, RectangleArea& drawArea) = 0;
	virtual void drawWireFrameSelection(DocWindow *docwin, RectangleArea& drawArea) = 0;
	
	virtual GDStyle *getStrokeStyle() = 0;
	virtual GDStyle *getFillStyle() = 0;

	virtual void setStrokeStyle(const GDStyle &from) { GDStyle *style = getStrokeStyle(); if (style) { *style |= from; } };
	virtual void setFillStyle(const GDStyle &from) { GDStyle *style = getFillStyle(); if (style) { *style |= from; } };
	
	virtual void setTextStyle(TextStyle& style) {};
	
	virtual void gatherResource(GDResourceList& collection, gint type) {};

};
#endif
