// generated 2004/1/11 19:01:26 CET by pklaus@atlanta.(none)
// using glademm V0.6.2b
//
// newer (non customized) versions of this file go to EditGradientDialog.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "EditGradientDialog.hh"
#include "Gradient.hh"
#include <libgnome/libgnome.h> // for _() macro

#define COLOR_POINT_WIDTH	3
#define COLOR_POINT_HEIGHT	(COLOR_POINT_WIDTH+COLOR_POINT_WIDTH+2)

EditGradientDialog::EditGradientDialog(Gradient *gradient) {
	inEdit = gradient;
	currCPoint = -1;
	posDiff = 0;
	nameEntry->set_text(gradient->name);
	if (gradient->type == GRADIENT_TYPE_LINEAR) {
		linearRadio->set_active(1);
		radialRadio->set_active(0);
	} else if (gradient->type == GRADIENT_TYPE_RADIAL) {
		linearRadio->set_active(0);
		radialRadio->set_active(1);
	}
}

void EditGradientDialog::onNameChange() {
	//g_printerr("EditGradientDialog::onNameChange\n");
	inEdit->name = nameEntry->get_text();
}

void EditGradientDialog::onTypeChange() {
	//g_printerr("EditGradientDialog::onTypeChange\n");
	if (linearRadio->get_active()) {
		inEdit->type = GRADIENT_TYPE_LINEAR;
	} else {
		inEdit->type = GRADIENT_TYPE_RADIAL;
	}
}


void EditGradientDialog::onResize(GtkAllocation *all) {
}

gint EditGradientDialog::onButtonPress(GdkEventButton *ev) {
	button = ev->button;
	if ((int) ev->y < gradientControl->height() - COLOR_POINT_HEIGHT) {
		return 0;
	}
	if (ev->type == GDK_BUTTON_PRESS) {
		//g_printerr("EditGradientDialog::onButtonPress got ButtonPress: %f,%f\n", ev->x, ev->y);
		int x = (int) (ev->x) - COLOR_POINT_WIDTH;
		gdouble cindex = (gdouble) x / (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH);
		vector<ColorPoint>::iterator it = inEdit->colorPoints.begin();
		ColorPoint low = *it;
		int count = 0;
		while (it != inEdit->colorPoints.end() && (*it).pos < cindex) {
			low = *it;
			count++;
			it++;
		}
		ColorPoint high = *it;
		int lowPos = (int) (low.pos * (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH));
		int highPos = (int) (high.pos * (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH));
		if (x - lowPos <= COLOR_POINT_WIDTH) {
			currCPoint = count - 1;
			posDiff = lowPos - x;
		} else if (highPos - x <= COLOR_POINT_WIDTH) {
			currCPoint = count;
			posDiff = highPos - x;
		} else if (ev->button == 1) {
			currCPoint = count;
			posDiff = 0;
			ColorPoint newPoint;
			newPoint.pos = cindex;
			guint rl, rh, gl, gh, bl, bh;
			low.color.getRGBColor(rl, gl, bl);
			high.color.getRGBColor(rh, gh, bh);
			gdouble cf = (cindex - low.pos) / (high.pos - low.pos);
			guint r = (guint) ((gint) rl + (gint) ( (gdouble) ((gint) rh - (gint) rl) * cf ));
			guint g = (guint) ((gint) gl + (gint) ( (gdouble) ((gint) gh - (gint) gl) * cf ));
			guint b = (guint) ((gint) bl + (gint) ( (gdouble) ((gint) bh - (gint) bl) * cf ));
			newPoint.color.setRGB(r, g, b);
			inEdit->colorPoints.insert(it, newPoint);
			drawGradientControl();
		} else {
			currCPoint = -1;
		}
		// special case below 0
		if (x <= 0) {
			currCPoint = 0;
			posDiff = -x;
		}
	} else if (ev->type == GDK_2BUTTON_PRESS) {
		// edit the color of the current ColorPoint
		//g_printerr("EditGradientDialog::onButtonPress got 2ButtonPress: %f,%f\n", ev->x, ev->y);
		if (currCPoint >= 0) {
			guint r, g, b;
			inEdit->colorPoints[currCPoint].color.getRGBColor(r, g, b);
			csd = new class Gtk::ColorSelectionDialog(_("Select Color"));
			gdouble col[4] = { r / 255.0, g / 255.0, b / 255.0, 1 };
			csd->get_colorsel()->set_color(col);
			csd->set_modal(1);
			csd->get_ok_button()->clicked.connect(SigC::slot(this, &EditGradientDialog::RGBSelectionOK));
			csd->get_cancel_button()->clicked.connect(csd->destroy.slot());
			csd->show();
		}
	}
	return 0;
}


void EditGradientDialog::RGBSelectionOK() {
	if (csd) {
		gdouble col[4];
		csd->get_colorsel()->get_color(col);
		guint r, g, b;
		r = (guint) (col[0] * 255.0);
		g = (guint) (col[1] * 255.0);
		b = (guint) (col[2] * 255.0);
		if (currCPoint >= 0) {
			inEdit->colorPoints[currCPoint].color.setRGB(r, g, b);
			drawGradientControl();
		}
		csd->destroy();
	}
}

gint EditGradientDialog::onMotion(GdkEventMotion *ev) {
	if (button == 1 && currCPoint > 0 && (guint) currCPoint < inEdit->colorPoints.size() - 1) {
		int x = (int) (ev->x) - COLOR_POINT_WIDTH + posDiff;
		gdouble cindex = (gdouble) x / (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH);
		inEdit->colorPoints[currCPoint].pos = cindex;
		drawGradientControl();
	}
		
	return 0;
}

gint EditGradientDialog::onButtonRelease(GdkEventButton *ev) {
	if (ev->type == GDK_BUTTON_RELEASE && ev->button == 3) {
		int x = (int) (ev->x) - COLOR_POINT_WIDTH;
		gdouble cindex = (gdouble) x / (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH);
		vector<ColorPoint>::iterator it = inEdit->colorPoints.begin();
		ColorPoint low = *it;
		vector<ColorPoint>::iterator last = it;
		guint count = 0;
		while (it != inEdit->colorPoints.end() && (*it).pos < cindex) {
			low = *it;
			last = it;
			count++;
			it++;
		}
		ColorPoint high = *it;
		int lowPos = (int) (low.pos * (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH));
		int highPos = (int) (high.pos * (gdouble) (gradientControl->width() - 1 - 2 * COLOR_POINT_WIDTH));
		if (x - lowPos <= COLOR_POINT_WIDTH) {
			if (count > 1) {
				inEdit->colorPoints.erase(last);
			}
			currCPoint = -1;
			posDiff = 0;
			drawGradientControl();
		} else if (highPos - x <= COLOR_POINT_WIDTH) {
			if (count < inEdit->colorPoints.size() - 2) {
				inEdit->colorPoints.erase(it);
			}
			currCPoint = -1;
			posDiff = 0;
			drawGradientControl();
		}
	}
	button = -1;
	return 0;
}

void EditGradientDialog::drawColorPoint(Gdk_Drawable& drawable, Gdk_GC& context, guint x, guint y) {
	GdkPoint gdkpts[5];
	gdkpts[0].x = x; gdkpts[0].y = y;
	gdkpts[1].x = x - COLOR_POINT_WIDTH; gdkpts[1].y = y + COLOR_POINT_WIDTH;
	gdkpts[2].x = x; gdkpts[2].y = y + 2 * COLOR_POINT_WIDTH;
	gdkpts[3].x = x + COLOR_POINT_WIDTH; gdkpts[3].y = y + COLOR_POINT_WIDTH;
	gdkpts[4].x = x; gdkpts[4].y = y;
	drawable.draw_polygon(context, 1, gdkpts, 5);
	Gdk_Color gcolor;
	gcolor.set_rgb(0, 0, 0);
	context.set_foreground(gcolor);
	drawable.draw_lines(context, gdkpts, 5);
}


gint EditGradientDialog::onExpose(GdkEventExpose *ev) {
	drawGradientControl();
	return 0;
}

void EditGradientDialog::drawGradientControl() {
	guint width = gradientControl->width();
	guint height = gradientControl->height();
	ColorPoint lowCP = inEdit->colorPoints[0];
	ColorPoint hiCP = inEdit->colorPoints[0];
	gdouble indInc = 1.0 / (gdouble) (width - 1 - 2 * COLOR_POINT_WIDTH);
	gdouble cindex = 0;
	guint cpindex = 0;
	guint rl = 0, rh = 0, gl = 0, gh = 0, bl = 0, bh = 0;
	lowCP.color.getRGBColor(rl, gl, bl);
	hiCP.color.getRGBColor(rh, gh, bh);
	//g_printerr("EditGradientDialog::onExpose lc=%X %X %X hc=%X %X %X\n", rl, gl, bl, rh, gh, bh);
	Gdk_Colormap cmap = Gdk_Colormap::get_system();
	Gdk_Color gcolor;
	Gdk_Window drawable = gradientControl->get_window();
	Gdk_GC context = Gdk_GC(drawable);
	Gdk_GC bgcontext = gradientControl->get_style()->get_bg_gc(GTK_STATE_NORMAL);
	drawable.draw_rectangle(bgcontext, 1, 0, 0, width, height);
	for (guint x = COLOR_POINT_WIDTH; x < width - COLOR_POINT_WIDTH; x++) {
		if (hiCP.pos <= cindex) {
			lowCP = hiCP;
			cpindex++;
			hiCP = inEdit->colorPoints[cpindex];
			rl = rh; gl = gh; bl = bh;
			hiCP.color.getRGBColor(rh, gh, bh);
			gcolor.set_rgb(rl << 8, gl << 8, bl << 8);
			cmap.alloc(gcolor);
			context.set_foreground(gcolor);
			drawColorPoint(drawable, context, x, height - COLOR_POINT_HEIGHT);
			//g_printerr("EditGradientDialog::onExpose lc=%X %X %X hc=%X %X %X\n", rl, gl, bl, rh, gh, bh);
		}
		gdouble cf = (cindex - lowCP.pos) / (hiCP.pos - lowCP.pos);
		gint r = (gint) rl + (gint) ( ((gdouble) rh - (gdouble) rl) * cf );
		gint g = (gint) gl + (gint) ( ((gdouble) gh - (gdouble) gl) * cf );
		gint b = (gint) bl + (gint) ( ((gdouble) bh - (gdouble) bl) * cf );
		//g_printerr("EditGradientDialog::onExpose x=%d color=%X %X %X cf=%f\n", x, r,g,b, cf);
		gcolor.set_rgb(r << 8, g << 8, b << 8);
		cmap.alloc(gcolor);
		context.set_foreground(gcolor);
		context.set_line_width(1);
		context.set_function(GDK_COPY);
		drawable.draw_line(context, x, 0, x, height - COLOR_POINT_HEIGHT - 1);
		cindex += indInc;
	}
}

EditGradientDialog::~EditGradientDialog() {
}
