/* $Id: FillColorDisplay.cc,v 1.3 2003/11/18 20:27:48 pklaus Exp $
 *
 * FillColorDisplay.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "FillColorDisplay.hh"


FillColorDisplay::FillColorDisplay() {
	r = 255;
	g = 255;
	b = 255;
}

void FillColorDisplay::setColor(guint red, guint green, guint blue) {
	r = red;
	g = green;
	b = blue;
	queue_draw();
}

void FillColorDisplay::getColor(guint& red, guint& green, guint& blue) {
	red = r;
	green = g;
	blue = b;
}

gint FillColorDisplay::expose_event_impl(GdkEventExpose *ev) {
	
	Gdk_Window drawable = get_window();
	Gdk_Colormap cmap = Gdk_Colormap::get_system();
	Gdk_GC colorGC(drawable);
	Gdk_Color color;
	if (r > 65000) {
		color.set_rgb(0xFF00, 0xFF00, 0xFF00);
	} else {
		color.set_rgb(r << 8, g << 8, b << 8);
	}
	cmap.alloc(color);
	colorGC.set_foreground(color);
	//g_printerr("FillColorDisplay::expose_event: draw in Color %d, %d, %d\n", r, g, b);
	drawable.draw_rectangle(colorGC, 1, 0, 0, width() - 1, height() - 1);
	if (r == 65535) {
		// transparent
		Gdk_Color gray;
		gray.set_rgb(0xD000, 0xD000, 0xD000);
		cmap.alloc(gray);
		colorGC.set_foreground(gray);
		drawable.draw_line(colorGC, 0, height() - 1, width() - 1, 0);
	} else if (r == 65534) {
		// not equal on all objects
		Gdk_Color gray;
		gray.set_rgb(0xD000, 0xD000, 0xD000);
		cmap.alloc(gray);
		colorGC.set_foreground(gray);
		for (int i = 0; i < width() + height();i+=6) {
			drawable.draw_line(colorGC, 0, height() - 1 - i, i, height() - 1);
		}
	}
	drawable.draw_rectangle(get_style()->get_black_gc(), 0, 0, 0, width() - 1, height() - 1);
	return 0;
}

FillColorDisplay::~FillColorDisplay() {
}
