/* $Id: Gradient.hh,v 1.3 2004/03/07 21:35:33 pklaus Exp $
 *
 * Gradient.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002-2004 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _GRADIENT_HH
#  define _GRADIENT_HH

#include "GDColor.hh"
#include "GDResource.hh"
#include <string>
#include <vector>

#define GRADIENT_TYPE_LINEAR	0
#define GRADIENT_TYPE_RADIAL	1


struct ColorPoint {
	gdouble pos;
	GDColor color;
};

class Gradient : public GDResource {

public:
	vector<ColorPoint>	colorPoints;
	string name;
	guint type;

	Gradient();

	Gradient(Gradient& style);
	
	Gradient operator=(Gradient& style);
	int operator==(Gradient& from);

	string getName() { return name; };
	void setName(string newname) { name = newname; };
	
	gint writePS(ostream& psout);
	gint writeXML(ostream& xmlout);
	
	
	virtual ~Gradient();
};

#endif
