/* $Id: GradientListOrgDialog.hh,v 1.2 2004/03/08 10:37:39 pklaus Exp $
 *
 * GradientListOrgDialog.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002-2004 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _GRADIENTLISTORGDIALOG_HH
#  define _GRADIENTLISTORGDIALOG_HH

#include "ListOrgDialog.hh"
#include <gdk--.h>
#include <vector>
#include "gestalter.h"

class GDApplication;
class Gradient;
class GDDocument;
class EditGradientDialog;

class GradientListOrgDialog : public ListOrgDialog {

private:
	Gradient *inEdit;
	Gradient *currentGradient;
	guint untitledNumber;
	EditGradientDialog *editGradientDlg;

	void showEditDialog(Gradient *toEdit);
	gint deleteEditGradientDialog(GdkEventAny *ev);
	void cancelEditGradientDialog();
	void saveChangedGradient();


public:
	GradientListOrgDialog(GDApplication *app);
	
	void onClickColumn(gint column);
	void onSelectRow(gint row, gint column, GdkEvent *event);
	void onResize(GtkAllocation *all);
	gint hideWindow(GdkEventAny *ev);
	void newClicked();
	void deleteClicked();
	void editClicked();
	void closeDialog();
	void setDocument(GDDocument *document);
	void updateList(GDDocument *document);
	static Gdk_Pixmap createGradientPreview(Gradient *gradient, Gdk_Pixmap& previewPixmap, Gdk_Bitmap& previewMask, GDDocument *document);

};
#endif
