/* $Id: MoveDialog.hh,v 1.2 2004/03/24 19:31:43 pklaus Exp $
 *
 * MoveDialog.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _MOVEDIALOG_HH
#  include "MoveDialog_glade.hh"
#  define _MOVEDIALOG_HH


#include "gestalter.h"
#include <string>
#include <glib--.h>

class GDApplication;

class MoveDialog : public MoveDialog_glade {
	
private:
	GDApplication *app;
	gboolean polarDisabled;
	gboolean axisDisabled;

	string doubleToString(gdouble val);

public:
	MoveDialog(GDApplication *application);

	Gtk::Button *getOKButton() { return okButton; };
	Gtk::Button *getCancelButton() { return cancelButton; };
	Gtk::Button *getCopyButton() { return copyButton; };

	void recalcPolar();
	void recalcAxis();
	
	gdouble getHorizontalTranslation();
	gdouble getVerticalTranslation();
};
#endif
