/* $Id: Pattern.hh,v 1.4 2004/03/23 11:42:41 pklaus Exp $
 *
 * Pattern.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002-2004 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _PATTERN_HH
#  define _PATTERN_HH

#include "TransformationMatrix.hh"
#include "GDResource.hh"
#include <string>

class ClipGroup;
class GDDocument;

class Pattern : public GDResource {
protected:
	string name;

public:
	ClipGroup *content;
	gdouble width;
	gdouble height;
	gdouble origFactor;

	Pattern(ClipGroup *cont, gdouble w, gdouble h, gdouble f = 1.0);

	Pattern(Pattern& from);

	
	Pattern operator=(Pattern& from);
	int operator==(Pattern& to);

	string getName() { return name; };
	void setName(string newname) { name = newname; };
	
	void setDocument(GDDocument *document);

	gint writePS(ostream& psout);
	gint writeXML(ostream& xmlout);
	
	virtual ~Pattern();
};

#endif
