/* $Id: PatternListOrgDialog.hh,v 1.2 2004/03/23 11:42:41 pklaus Exp $
 *
 * PatternListOrgDialog.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002-2004 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _PATTERNLISTORGDIALOG_HH
#  define _PATTERNLISTORGDIALOG_HH

#include "ListOrgDialog.hh"
#include <gdk--.h>
#include <vector>
#include "gestalter.h"

class GDApplication;
class Pattern;
class GDDocument;
class EditPatternDialog;

class PatternListOrgDialog : public ListOrgDialog {

private:
	Pattern *inEdit;
	Pattern *currentPattern;
	guint untitledNumber;
	EditPatternDialog *editPatternDlg;

	void showEditDialog(Pattern *toEdit);
	gint deleteEditPatternDialog(GdkEventAny *ev);
	void cancelEditPatternDialog();
	void saveChangedPattern();


public:
	PatternListOrgDialog(GDApplication *app);
	
	void onClickColumn(gint column);
	void onSelectRow(gint row, gint column, GdkEvent *event);
	void onResize(GtkAllocation *all);
	gint hideWindow(GdkEventAny *ev);
	void newClicked();
	void deleteClicked();
	void editClicked();
	void closeDialog();
	void setDocument(GDDocument *document);
	void updateList(GDDocument *document);
	static Gdk_Pixmap createPatternPreview(Pattern *gradient, Gdk_Pixmap& previewPixmap, Gdk_Bitmap& previewMask, Gdk_GC& context, GDDocument *document);

};
#endif
