/* $Id: PatternListSelectionDialog.hh,v 1.1 2004/03/20 00:04:16 pklaus Exp $
 *
 * PatternListSelectionDialog.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002-2004 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _PATTERNLISTSELECTIONDIALOG_HH
#  define _PATTERNLISTSELECTIONDIALOG_HH
#  include "ListSelectionDialog.hh"

class GDDocument;
class Pattern;

class PatternListSelectionDialog : public ListSelectionDialog {

private:
	Pattern *currentPattern;
	GDDocument *doc;
	
public:
	
	PatternListSelectionDialog(GDDocument *document, Pattern *active);
	void onClickColumn(gint column);
	void onSelectRow(gint row, gint column, GdkEvent *event);
	void onResize(GtkAllocation *all);
	void updateList(GDDocument *document);
	Pattern *getSelectedPattern() { return currentPattern; };
	~PatternListSelectionDialog();
};
#endif
