/* $Id: PixelImageData.hh,v 1.6 2003/01/20 18:42:48 pklaus Exp $
 *
 * PixelImageData.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _PIXELIMAGEDATA_HH
#  define _PIXELIMAGEDATA_HH

#include "gestalter.h"
#include <glib--.h>
#include <string>
#include <stdio.h>
#include <gdk--.h>
#include "GObject.hh"

class PixelImageData {

	gint referenceCount;
	guchar *pixelCopy(guchar *dest, guchar *src, int width, int height, 
												int incpp, int outcpp);
	void writeHexByte(ostream& out, guchar val);
public:
	guchar *data;
	guint width;
	guint height;
	guint rowstride;


	PixelImageData();
	PixelImageData(string filename);
	void incRefCount();
	void decRefCount();
	void writeXML(ostream& xmlout);
	void writePS(ostream& psout);
	void writePSColor(ostream& psout);
	void writePSMask(ostream& psout);
	void writePSGray(ostream& psout);
	~PixelImageData();
};

#endif
