/* $Id: PropertiesSpinButton.cc,v 1.3 2003/11/18 20:27:48 pklaus Exp $
 *
 * PropertiesSpinButton.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "PropertiesSpinButton.hh"
#include <gtk--/adjustment.h>
#include <gtk--/spinbutton.h>
#include <gtk--/widget.h>



PropertiesSpinButton::PropertiesSpinButton(Gtk::Adjustment &adjustment, gfloat climb_rate, gint digits)
		: Gtk::SpinButton(adjustment, climb_rate, digits) {
}

gint PropertiesSpinButton::focus_out_event_impl(GdkEventFocus *evt) {
	//g_printerr("PropertiesSpinButton::focus_out_event_impl\n");
	if (get_text().size() > 0) {
		//g_printerr("PropertiesSpinButton::focus_out_event_impl call super\n");
		Gtk::Widget::focus_out_event_impl(evt);
	} else {
		//g_printerr("PropertiesSpinButton::focus_out_event_impl entry empty\n");
		gtk_editable_set_editable((GtkEditable *) Gtk::Widget::gtkobj(), false);
		Gtk::Widget::focus_out_event_impl(evt);
		gtk_editable_set_editable((GtkEditable *) Gtk::Widget::gtkobj(), true);
	}
	return 0;
}

PropertiesSpinButton::~PropertiesSpinButton() {
}
