/* $Id: ScaleDialog.cc,v 1.2 2003/12/06 21:42:11 pklaus Exp $
 *
 * ScaleDialog.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "config.h"
#include "ScaleDialog.hh"


Gtk::Button *ScaleDialog::getOKButton() {
	return okButton;
}

Gtk::Button *ScaleDialog::getCancelButton() {
	return cancelButton;
}

Gtk::Button *ScaleDialog::getCopyButton() {
	return copyButton;
}

gdouble ScaleDialog::getPercentField(Gtk::Entry *entry) {
	gdouble percent = strtod(entry->get_text().c_str(), NULL);
	return percent / 100;
}

gdouble ScaleDialog::getHorizontalScale() {
	if (uniformRadio->get_active()) {
		return getPercentField(uniformEntry);
	} else {
		return getPercentField(horizontalEntry);
	}
}

gdouble ScaleDialog::getVerticalScale() {
	if (uniformRadio->get_active()) {
		return getPercentField(uniformEntry);
	} else {
		return getPercentField(verticalEntry);
	}
}

gboolean ScaleDialog::getScaleLineWeight() {
	if (uniformRadio->get_active()) {
		return scaleLineWeight->get_active();
	} else {
		return false;
	}
}

void ScaleDialog::scaleTypeToggled() {
	if (uniformRadio->get_active()) {
		uniformEntry->set_sensitive(1);
		scaleLineWeight->set_sensitive(1);
		horizontalEntry->set_sensitive(0);
		verticalEntry->set_sensitive(0);
	} else {
		uniformEntry->set_sensitive(0);
		scaleLineWeight->set_sensitive(0);
		horizontalEntry->set_sensitive(1);
		verticalEntry->set_sensitive(1);
	}
}
