/* $Id: SelectionItem.cc,v 1.3 2003/06/23 07:14:21 pklaus Exp $
 *
 * SelectionItem.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "SelectionItem.hh"
#include "SelectableItem.hh"

SelectionItem::SelectionItem(SelectableItem *item, gint mode) {
	orig = item;
	if (mode == SELECTIONITEM_MODE_COPY_OBJECT) {
		moving = item->clone();
	} else {
		moving = NULL;
	}
}

SelectionItem::~SelectionItem() {
	if (moving) {
		//g_printerr("SelectionItem::~SelectionItem Delete the moving node\n");
		//g_printerr("Moving node is a %s\n", moving->identify());
		delete moving;
		//g_printerr("Moving node removed\n");
	}
}
