/* $Id: StringHashTable.hh,v 1.2 2002/12/29 16:43:40 pklaus Exp $
 *
 * StringHashTable.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _STRINGHASHTABLE_HH
#  define _STRINGHASHTABLE_HH

#include <glib.h>

template <class T>
class StringHashTable {

	GHashTable	*ht;

public:

	StringHashTable() { ht = g_hash_table_new(&g_str_hash, &g_str_equal); }
	
	void insert(gchar *key, const T& value) { g_hash_table_insert(ht, key, value); }
	
	gint size() { return g_hash_table_size(ht); }
	
	T lookup(gchar *key) { return (T) g_hash_table_lookup(ht, key); }
	
	void remove(gchar *key) { g_hash_table_remove(ht, key); }
	
	void freeze() { g_hash_table_freeze(ht); }
	
	void thaw() { g_hash_table_thaw(ht); }
	
	GHashTable *gtkobj() { return ht; }
	
	~StringHashTable() { g_hash_table_destroy(ht); }

};

#endif
