/* $Id: TMatrixTool.hh,v 1.4 2004/03/20 00:01:37 pklaus Exp $
 *
 * TMatrixTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _TMATRIXTOOL_HH
#  define _TMATRIXTOOL_HH

#include "Tool.hh"
#include <gdk--.h>

class TransformationMatrix;
class SelectionItemList;
class GDDocument;

#define TMATRIX_MODE_CENTER_SET		1
#define TMATRIX_MODE_DIALOG			2

class TMatrixTool : public Tool, public SigC::Object {

protected:
	gint downButton;
	
	gdouble sx, sy, cx, cy;
	gint mode;

	Gdk_Cursor crosshairCursor;
	Gdk_Cursor moveCursor;
	Gdk_Cursor moveMagnetCursor;

	GDDocument *dialogDoc;
	
	gboolean nodeCaught;
	SelectionItemList *selection;
	
	virtual TransformationMatrix calcMatrix(gdouble sx, gdouble sy, 
						gdouble cx, gdouble cy,
						gdouble x, gdouble y, gint state) = 0;
	virtual void showValueDialog() = 0;

public:
	
	TMatrixTool();
	
	virtual void activate();
	virtual void deactivate();
	virtual gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	virtual gint motion(GdkEventMotion *ev, DocWindow *docwin);
	virtual gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	virtual gint showOptions();
	
	virtual void setCursor(guint state, DocWindow *docwin);

	virtual void doTransform(TransformationMatrix &tm, gboolean copy, gboolean positionOnly = false);
	
};


#endif
