/* $Id: TextProperties.hh,v 1.9 2003/11/16 18:26:53 pklaus Exp $
 *
 * TextProperties.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



// generated 2002/11/10 18:45:43 CET by pklaus@iron.pylonsoft.ch.(none)
// using glademm V1.1.2
//
// newer (non customized) versions of this file go to TextProperties.hh_new

// you might replace
//    class foo : public foo_glade { ... };
// by
//    typedef foo_glade foo;
// if you didn't make any modifications to the widget

#ifndef _TEXTPROPERTIES_HH
//#  include "TextProperties_glade.hh"
#  define _TEXTPROPERTIES_HH
#include "glademm_support.hh"
#include "FontPool.hh"
#include "PropertiesSpinButton.hh"
#include "UnitsSpinButton.hh"

#if !defined(GLADEMM_DATA)
#define GLADEMM_DATA 
#include <gtk--/accelgroup.h>

class GlademmData
{  
        
        Gtk::AccelGroup *accgrp;
public:
        
        GlademmData(Gtk::AccelGroup *ag) : accgrp(ag)
        {  
        }
        
        Gtk::AccelGroup * getAccelGroup()
        {  return accgrp;
        }
};
#endif //GLADEMM_DATA

#include <gtk--/window.h>
#include <gtk--/entry.h>
#include <gtk--/combo.h>
#include <gtk--/spinbutton.h>
#include <gtk--/checkbutton.h>

class GDDocument;
class GDApplication;

//class TextProperties : public TextProperties_glade {
class TextProperties : public Gtk::Window {

// from TextProperties_glade

        GlademmData *_data;
protected:
        class Gtk::Combo *FamilyCombo;
        class Gtk::Combo *FaceCombo;
        class UnitsSpinButton *TextSizeSpinButton;
        class UnitsSpinButton *LineSpaceSpinButton;
        class Gtk::CheckButton *AutoLineSpaceCheckButton;
        class UnitsSpinButton *BaseLineShiftSpinButton;
        class PropertiesSpinButton *TrackingSpinButton;
        class PropertiesSpinButton *HorizontalScaleSpinButton;
        
// end from TextProperties_glade

private:
	GDApplication *application;
	FontMap currentFamily;
	GDFont *currentFace;
	gboolean familyDisabled;
	gboolean faceDisabled;
	GDDocument *currentDoc;
	SigC::Connection selConnection;
	gboolean updateAllowed;

public:

	TextProperties(GDApplication *gda);
	
	void checkFamilyDelete(gint start_pos, gint end_pos);
	gint keyPressFamily(GdkEventKey *ev);
	void checkFamilyInsert(const gchar *text, gint length, gint *position);
	void checkFaceDelete(gint start_pos, gint end_pos);
	void checkFaceInsert(const gchar *text, gint length, gint *position);
	void changeTextSize();
	void changeLineSpace();
	void on_AutoLineSpaceCheckButton_toggled();
	void changeBaseLineShift();
	void changeTracking();
	void changeHorizontalScale();
	
	void setDocument(GDDocument *document);
	void createFamilyMenu();
	void createFaceMenu();
	void setFamily();
	void setFace();
	
	void setTextFont();
	
	void fillFont(GDFont *font, gboolean valid);
	void fillPointSize(gdouble size, gboolean valid);
	void fillLineSpace(gdouble space, gboolean valid);
	void fillAutoLineSpace(gboolean autoLS, gboolean valid);
	void fillBaseLineShift(gdouble shift, gboolean valid);
	void fillTracking(gdouble tracking, gboolean valid);
	void fillHorizontalScale(gdouble scale, gboolean valid);
	
	void updateValues(GDDocument *document);
	
	gint sbFocusOut(GdkEventFocus *evt);
	
	gint hideTextProperties(GdkEventAny *ev);

	void onPrefsChanged(Preferences *newPrefs);
	
	~TextProperties();
};
#endif
