/* $Id: ToolWindow.hh,v 1.7 2004/03/30 18:40:47 pklaus Exp $
 *
 * ToolWindow.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



// generated 2001/11/11 17:24:34 CET by pklaus@iron.
// using glademm V0.6.2
//
// newer (non customized) versions of this file go to ToolWindow.hh_new

// you might replace
//    class foo : public foo_glade { ... };
// by
//    typedef foo_glade foo;
// if you didn't make any modifications to the widget

#ifndef _TOOLWINDOW_HH
#  include "ToolWindow_glade.hh"
#  define _TOOLWINDOW_HH

#include <gtk--/base.h>
#include <gtk--/box.h>
#include <gtk--/style.h>
#include <gtk--/fileselection.h>
#include <gtk--/radiobutton.h>
#include "Preferences.hh"

class GDDocument;
class DocumentMenu;
class Tool;
class HWrapBox;
class Properties;
class FontPool;
class TextProperties;
class GDApplication;
class PreferencesDialog;

class ToolWindow : public ToolWindow_glade
{   

protected:
	G_ListImpl *toolList;
	HWrapBox *toolWrapBox;
	Gtk::FileSelection *fileselection;
	Gtk::RadioButton_Helpers::Group radioGroup;
	GDApplication *application;
	PreferencesDialog *preferencesDialog;
		
private:
	friend class ToolWindow_glade;
	
	int numTools;

public:
	void onPreferences();
	void on_file_activate();
	void on_show_help_activate();
	void show_about();
	gint app_exit(GdkEventAny *ev);
	void savePrefs();
	void cancelPrefs();

	ToolWindow(GDApplication *gda);
	void save_exit();
	void on_new_document_activate();
	void on_open_document_activate();
	void sigSetTool(gchar *name);
	void addTool(Tool *tool);
	void setGeometry();
	
	// selection handling (copy/paste)
	gint on_selection_clear_event(GdkEventSelection *ev);
	void on_selection_get(GtkSelectionData *selection_data,guint info,guint time);
	gint on_selection_notify_event(GdkEventSelection *ev);
	void on_selection_received(GtkSelectionData *selection_data,guint time);
	gint on_selection_request_event(GdkEventSelection *ev);
	
	
	void openDocument();
	
	~ToolWindow();
};
#endif
